/*------------------------------------------------------------------------
 * header for term attribute processing
 *
 * This header is public.
 */
#ifndef TCAPVALS_H
#define TCAPVALS_H

/*------------------------------------------------------------------------
 * C++ stuff
 */
#ifdef __cplusplus
extern "C" {
#endif

/*------------------------------------------------------------------------
 * functions
 */
extern int			tcap_set_term_db		(const char *term_db_type);
extern const char *	tcap_get_term_db		(void);

extern const char *	tcap_get_term_db_name	(int num);
extern const char *	tcap_get_term_db_desc	(int num);

extern int			tcap_dump_term			(const char *term, FILE *fp);

extern int			tcap_set_icon			(TERMINAL *sp,
												int width, int height,
												const unsigned char *bits);

extern int			tcap_set_evt_rtn		(TERMINAL *sp,
												int (*rtn)(void *data, int ms),
												void *data);

extern int			tcap_set_inp_rtn		(TERMINAL *sp,
												int (*rtn)(int mode,
													void *data,
													int ms),
												void *data);

extern int			tcap_set_out_rtn		(TERMINAL *sp,
												int (*rtn)(int moed,
													void *data,
													const unsigned char *buf,
													int n),
												void *data);

extern int			tcap_get_window_env		(void);
extern int			tcap_get_disp_in_win	(const TERMINAL *sp);
extern int			tcap_get_max_cols		(const TERMINAL *sp);
extern int			tcap_get_max_rows		(const TERMINAL *sp);
extern int			tcap_get_tab_size		(const TERMINAL *sp);
extern const char *	tcap_get_termname		(const TERMINAL *sp);
extern const char *	tcap_get_longname		(const TERMINAL *sp);
extern const char *	tcap_get_termtype		(const TERMINAL *sp);
extern const char *	tcap_get_ttyname		(const TERMINAL *sp);
extern attr_t		tcap_get_termattrs		(const TERMINAL *sp);

extern attr_t		tcap_get_orig_attr		(const TERMINAL *sp);
extern int			tcap_get_has_ic			(const TERMINAL *sp);
extern int			tcap_get_has_il			(const TERMINAL *sp);

extern int			tcap_get_cmdstr_by_enum	(const TERMINAL *sp, SCRN_CMD cmd,
												char *buf);

extern int			tcap_get_cmdstr_by_name	(const TERMINAL *sp,
												const char *name,
												SCRN_CMD *pcmd, char *buf);

extern int			tcap_get_cmdstr_by_str	(const TERMINAL *sp,
												const char *str,
												SCRN_CMD *pcmd, char *buf,
												int *pp1, int *pp2);

extern int			tcap_get_default_attrs	(const TERMINAL *sp,
												attr_t *pr, attr_t *ps,
												int use_color, int use_win);

/*------------------------------------------------------------------------
 * C++ stuff
 */
#ifdef __cplusplus
}
#endif

#endif /* TCAPVALS_H */
