/*------------------------------------------------------------------------
 * sound routines
 */
#include "tcapcommon.h"

/*------------------------------------------------------------------------
 * tcap_beep() - ring bell if possible or flash if possible
 */
int tcap_beep (TERMINAL *sp)
{
	if (sp == 0)
		return (-1);

	if (is_cmd_pres(sp->tcap->strs.bl))
		tcap_outcmd(sp, S_BL, sp->tcap->strs.bl);
	else if (is_cmd_pres(sp->tcap->strs.vb))
		tcap_outcmd(sp, S_VB, sp->tcap->strs.vb);
	else
		tcap_outc(sp, KEY_BL);

	tcap_outflush(sp);

	return (0);
}

/*------------------------------------------------------------------------
 * tcap_flash() - flash if possible or ring bell if possible
 */
int tcap_flash (TERMINAL *sp)
{
	if (sp == 0)
		return (-1);

	if (is_cmd_pres(sp->tcap->strs.vb))
		tcap_outcmd(sp, S_VB, sp->tcap->strs.vb);
	else if (is_cmd_pres(sp->tcap->strs.bl))
		tcap_outcmd(sp, S_BL, sp->tcap->strs.bl);

	tcap_outflush(sp);

	return (0);
}
