/*------------------------------------------------------------------------
 * mode functions
 *
 * This header is public.
 */
#ifndef TCMODE_H
#define TCMODE_H

/*------------------------------------------------------------------------
 * C++ stuff
 */
#ifdef __cplusplus
extern "C" {
#endif

/*------------------------------------------------------------------------
 * functions
 */
extern int	tcap_get_baud_rate	(const TERMINAL *sp);
extern int	tcap_get_kill_char	(const TERMINAL *sp);
extern int	tcap_get_quit_char	(const TERMINAL *sp);
extern int	tcap_get_intr_char	(const TERMINAL *sp);
extern int	tcap_get_erase_char	(const TERMINAL *sp);
extern int	tcap_get_wait		(const TERMINAL *sp);

extern int	tcap_set_baud_rate	(TERMINAL *sp, int br);
extern int	tcap_set_kill_char	(TERMINAL *sp, int ch);
extern int	tcap_set_quit_char	(TERMINAL *sp, int ch);
extern int	tcap_set_intr_char	(TERMINAL *sp, int ch);
extern int	tcap_set_erase_char	(TERMINAL *sp, int ch);
extern int	tcap_set_wait		(TERMINAL *sp, int bf);

extern int	tcap_flush_inp		(TERMINAL *sp);
extern int	tcap_flush_out		(TERMINAL *sp);

extern int	tcap_set_typeahead	(TERMINAL *sp, int fildes);
extern int	tcap_set_halfdelay	(TERMINAL *sp, int tenths);

/*------------------------------------------------------------------------
 * C++ stuff
 */
#ifdef __cplusplus
}
#endif

#endif /* TCMODE_H */
