/*------------------------------------------------------------------------
 * screen routines
 */
#include "tcapcommon.h"

/*------------------------------------------------------------------------
 * tcap_init_terminal() - initialize a TERMINAL
 */
TERMINAL *tcap_init_terminal (void)
{
	TERMINAL *sp;

	sp = (TERMINAL *)MALLOC(sizeof(*sp));
	if (sp != 0)
	{
		sp->crit	= sysmutex_alloc       ();
		sp->tcap	= tcap_init_tcap_data  ();
		sp->scrn	= tcap_init_screen_data();
		sp->term	= term_screen_dev_init ();

		if (sp->crit == 0 ||
		    sp->tcap == 0 ||
		    sp->scrn == 0 ||
		    sp->term == 0)
		{
			tcap_free_terminal(sp);
			sp = 0;
		}
	}

	return (sp);
}

/*------------------------------------------------------------------------
 * tcap_free_terminal() - free a TERMINAL
 */
void tcap_free_terminal (TERMINAL *sp)
{
	if (sp != 0)
	{
		if (sp->crit != 0)	sysmutex_free        (sp->crit);
		if (sp->scrn != 0)	tcap_free_screen_data(sp->scrn);
		if (sp->tcap != 0)	tcap_free_tcap_data  (sp->tcap);
		if (sp->term != 0)	term_screen_dev_free (sp->term);

		FREE(sp);
	}
}
