/*------------------------------------------------------------------------
 * sleep for given milliseconds
 */
#include "termcommon.h"

#if V_UNIX
#  if defined(__APPLE__) || defined(__APPLE_CC__)
#    ifndef NO_POLL_H
#      define NO_POLL_H		1
#    endif
#  endif
#  if ! NO_POLL_H
#    include <poll.h>
#  endif
#endif

/*------------------------------------------------------------------------
 * term_nap() - sleep for given milliseconds
 */
void term_nap (int ms)
{
#if V_UNIX
#  if NO_POLL_H
   struct timeval	tv;

	tv.tv_sec	= 0;
	tv.tv_usec	= ms * 1000;
	select(0, 0, 0, 0, &tv);
#  else
	poll(0, 0, ms);
#  endif
#else
	Sleep(ms);
#endif
}
