/*------------------------------------------------------------------------
 * curses interfaces
 */
#include "wincommon.h"

/*------------------------------------------------------------------------
 * curses kernel routines (ecurs_kernel)
 */
int curs_set (int visibility)
{
	return scr_curs_set(win_cur_screen, visibility);
}

int set_syx (int y, int x)
{
	return scr_set_syx(win_cur_screen, y, x);
}

int get_syx (int *y, int *x)
{
	return scr_get_syx(win_cur_screen, y, x);
}

int def_shell_mode (void)
{
	return scr_def_shell_mode(win_cur_screen);
}

int reset_shell_mode (void)
{
	return scr_reset_shell_mode(win_cur_screen);
}

int def_prog_mode (void)
{
	return scr_def_prog_mode(win_cur_screen);
}

int reset_prog_mode (void)
{
	return scr_reset_prog_mode(win_cur_screen);
}

int savetty (void)
{
	return scr_savetty(win_cur_screen);
}

int resetty (void)
{
	return scr_resetty(win_cur_screen);
}

/*------------------------------------------------------------------------
 * alarm functions (ecurs_beep)
 */
int beep (void)
{
	return scr_beep(win_cur_screen);
}

int flash (void)
{
	return scr_flash(win_cur_screen);
}

/*------------------------------------------------------------------------
 * input options (ecurs_inopts)
 */
int nlinp (void)
{
	return scr_nlinp(win_cur_screen);
}

int nonlinp (void)
{
	return scr_nonlinp(win_cur_screen);
}

int raw (void)
{
	return scr_raw(win_cur_screen);
}

int noraw (void)
{
	return scr_noraw(win_cur_screen);
}

int cbreak (void)
{
	return scr_cbreak(win_cur_screen);
}

int nocbreak (void)
{
	return scr_nocbreak(win_cur_screen);
}

int echo (void)
{
	return scr_echo(win_cur_screen);
}

int noecho (void)
{
	return scr_noecho(win_cur_screen);
}

int metaon (void)
{
	return scr_metaon(win_cur_screen);
}

int metaoff (void)
{
	return scr_metaoff(win_cur_screen);
}

int qiflush (void)
{
	return scr_qiflush(win_cur_screen);
}

int noqiflush (void)
{
	return scr_noqiflush(win_cur_screen);
}

int typeahead (int fildes)
{
	return scr_typeahead(win_cur_screen, fildes);
}

int halfdelay (int tenths)
{
	return scr_halfdelay(win_cur_screen, tenths);
}

int addkey (const char *string, int code)
{
	return scr_addkey(win_cur_screen, string, code);
}

/*------------------------------------------------------------------------
 * output options (ecurs_outopts)
 */
int nl (void)
{
	return scr_nl(win_cur_screen);
}

int nonl (void)
{
	return scr_nonl(win_cur_screen);
}

int nlout (void)
{
	return scr_nlout(win_cur_screen);
}

int nonlout (void)
{
	return scr_nonlout(win_cur_screen);
}

int get_valid_acs (int c)
{
	return scr_get_valid_acs(win_cur_screen, c);
}

int set_valid_acs (int bf)
{
	return scr_set_valid_acs(win_cur_screen, bf);
}

/*------------------------------------------------------------------------
 * terminal attribute functions (ecurs_termattrs)
 */
int baudrate (void)
{
	return scr_baudrate(win_cur_screen);
}

int killchar (void)
{
	return scr_killchar(win_cur_screen);
}

int erasechar (void)
{
	return scr_erasechar(win_cur_screen);
}

int quitchar (void)
{
	return scr_quitchar(win_cur_screen);
}

int intrchar (void)
{
	return scr_intrchar(win_cur_screen);
}

int has_ic (void)
{
	return scr_has_ic(win_cur_screen);
}

int has_il (void)
{
	return scr_has_il(win_cur_screen);
}

int get_window_env (void)
{
	return scr_get_window_env(win_cur_screen);
}

attr_t termattrs (void)
{
	return scr_termattrs(win_cur_screen);
}

const char * termname (void)
{
	return scr_termname(win_cur_screen);
}

const char * longname (void)
{
	return scr_longname(win_cur_screen);
}

const char * termtype (void)
{
	return scr_termtype(win_cur_screen);
}

const char * get_ttyname (void)
{
	return scr_get_ttyname(win_cur_screen);
}

int get_curr_row (void)
{
	return scr_get_curr_row(win_cur_screen);
}

int get_curr_col (void)
{
	return scr_get_curr_col(win_cur_screen);
}

int get_max_cols (void)
{
	return scr_get_max_cols(win_cur_screen);
}

int get_max_rows (void)
{
	return scr_get_max_rows(win_cur_screen);
}

int get_tab_size (void)
{
	return scr_get_tab_size(win_cur_screen);
}

attr_t get_orig_attr (void)
{
	return scr_get_orig_attr(win_cur_screen);
}

attr_t get_curr_attr (void)
{
	return scr_get_curr_attr(win_cur_screen);
}

/*------------------------------------------------------------------------
 * utility functions (ecurs_util)
 */
int flushinp (void)
{
	return scr_flushinp(win_cur_screen);
}

int delay_output (int ms)
{
	return scr_delay_output(win_cur_screen, ms);
}

int filter (void)
{
	return scr_filter(win_cur_screen);
}

/*------------------------------------------------------------------------
 * color functions (ecurs_color)
 */
int start_color (void)
{
	return scr_start_color(win_cur_screen);
}

int has_colors (void)
{
	return scr_has_colors(win_cur_screen);
}

int init_pair (short pair, short  f, short  b)
{
	return scr_init_pair(win_cur_screen, pair, f, b);
}

int pair_content (short pair, short *f, short *b)
{
	return scr_pair_content(win_cur_screen, pair, f, b);
}

int init_all_pairs (void)
{
	return scr_init_all_pairs(win_cur_screen);
}

int color_content (short color, short *r, short *g, short *b)
{
	return scr_color_content(win_cur_screen, color, r, g, b);
}

int init_color (short color, short  r, short  g, short  b)
{
	return scr_init_color(win_cur_screen, color, r, g, b);
}

int can_change_color (void)
{
	return scr_can_change_color(win_cur_screen);
}

int PAIR_NUMBER (attr_t a)
{
	return scr_pair_number(win_cur_screen, a);
}

attr_t COLOR_PAIR (int n)
{
	return scr_color_pair(win_cur_screen, n);
}

/*------------------------------------------------------------------------
 * cmd-exec functions (ecurs_exec)
 */
int exec_argv (const char *dir, char **argv, int interactive,
	char *msgbuf)
{
	return scr_exec_argv(win_cur_screen, dir, argv, interactive, msgbuf);
}

int exec_cmd (const char *dir, const char *cmd, int interactive,
	char *msgbuf)
{
	return scr_exec_cmd(win_cur_screen, dir, cmd, interactive, msgbuf);
}

/*------------------------------------------------------------------------
 * mouse functions (ecurs_mouse)
 */
int mouse_init (WINDOW *win)
{
	if (win == 0)
		return (ERR);

	return scr_mouse_init(WIN_SCREEN(win));
}

int mouse_get_display (WINDOW *win)
{
	if (win == 0)
		return (ERR);

	return scr_mouse_get_display(WIN_SCREEN(win));
}

int mouse_get_event (WINDOW *win)
{
	if (win == 0)
		return (ERR);

	return scr_mouse_get_event(WIN_SCREEN(win));
}

int mouse_x (WINDOW *win)
{
	if (win == 0)
		return (ERR);

	return scr_mouse_x(WIN_SCREEN(win));
}

int mouse_y (WINDOW *win)
{
	if (win == 0)
		return (ERR);

	return scr_mouse_y(WIN_SCREEN(win));
}

int mouse_c (WINDOW *win)
{
	int		x;
	int		y;
	int		c;
	chtype	ch;

	if (win == 0)
		return (ERR);
	win = WIN_CURSCR(win);

	x = mouse_x(win);
	y = mouse_y(win);

	if (x < 0 || x >= getmaxx(win))
		return (ERR);

	if (y < 0 || y >= getmaxy(win))
		return (ERR);

	ch = wchat(win, y, x);
	c = A_GETCODE(ch);

	return (c);
}

/*------------------------------------------------------------------------
 * mono/color attribute functions (ecurs_attributes)
 */
int get_default_attrs (attr_t *pr, attr_t *ps, int use_color, int use_win)
{
	return scr_get_default_attrs(win_cur_screen, pr, ps, use_color, use_win);
}

/*------------------------------------------------------------------------
 * signal routines (ecurs_signal)
 */
void set_signal_rtn (int sig, WIN_SIG_RTN *rtn, void *data)
{
	scr_set_signal_rtn(win_cur_screen, sig, rtn, data);
}

WIN_SIG_RTN * get_signal_rtn (int sig)
{
	return scr_get_signal_rtn(win_cur_screen, sig);
}

void * get_signal_data (int sig)
{
	return scr_get_signal_data(win_cur_screen, sig);
}

/*------------------------------------------------------------------------
 * miscellaneous routines (ecurs_misc)
 */
int blank_screen (const char **logo)
{
	return scr_blank_screen(win_cur_screen, logo);
}

int set_title (const char *s)
{
	return scr_set_title(win_cur_screen, s);
}

int set_async_key (int key, WIN_ASYNC_KEY_RTN *rtn, void *data)
{
	return scr_set_async_key(win_cur_screen, key, rtn, data);
}

int set_icon (int width, int height, const unsigned char *bits)
{
	return scr_set_icon(win_cur_screen, width, height, bits);
}

int set_debug_scr (const char *path, int bf, int text)
{
	return scr_set_debug_scr(win_cur_screen, path, bf, text);
}

int set_debug_kbd (const char *path, int bf, int text)
{
	return scr_set_debug_kbd(win_cur_screen, path, bf, text);
}

int set_event_rtn (int (*rtn)(void *data, int ms),
	void *data)
{
	return scr_set_event_rtn(win_cur_screen, rtn, data);
}

int set_input_rtn (
	int (*rtn)(int mode, void *data, int ms),
	void *data)
{
	return scr_set_input_rtn(win_cur_screen, rtn, data);
}

int set_output_rtn (
	int (*rtn)(int mode, void *data, const unsigned char *buf, int n),
	void *data)
{
	return scr_set_output_rtn(win_cur_screen, rtn, data);
}
